import { openBlock as l, createElementBlock as s, createElementVNode as r, toDisplayString as u, renderSlot as f, ref as C, computed as y, normalizeClass as B, createVNode as M, withCtx as $, useSlots as O, createCommentVNode as c, unref as q, resolveComponent as D, Fragment as x, renderList as V, createBlock as k, createTextVNode as A, inject as I, withDirectives as z, vModelDynamic as H, provide as U, watch as K, resolveDynamicComponent as F, normalizeStyle as Y, vModelCheckbox as P, onMounted as E, withKeys as j, withModifiers as N, vModelSelect as ee } from "vue";
import te from "fuse.js";
import { getProperty as R } from "dot-prop";
import { RouterLink as Z } from "vue-router";
const le = {
  key: 0,
  class: "cf-action-card"
}, se = { class: "cf-action-card__body" }, oe = { class: "cf-action-card__title" }, ne = { class: "cf-action-card__body__slot" }, ae = { class: "cf-action-card__action" }, re = {
  key: 1,
  class: "cf-simple-action-card"
}, Ol = {
  __name: "ActionCard",
  props: {
    title: String,
    simple: Boolean
  },
  setup(o) {
    const t = o;
    return (e, n) => t.simple ? (l(), s("div", re, [
      r("div", null, [
        f(e.$slots, "body")
      ]),
      r("div", null, [
        f(e.$slots, "action")
      ])
    ])) : (l(), s("div", le, [
      r("div", se, [
        r("div", oe, u(t.title), 1),
        r("div", ne, [
          f(e.$slots, "body")
        ])
      ]),
      r("div", ae, [
        f(e.$slots, "action")
      ])
    ]));
  }
};
const G = (o, t) => {
  const e = o.__vccOpts || o;
  for (const [n, a] of t)
    e[n] = a;
  return e;
}, ie = {}, ue = { class: "cf-app-bar" };
function de(o, t) {
  return l(), s("header", ue, [
    r("div", null, [
      f(o.$slots, "left")
    ]),
    r("div", null, [
      f(o.$slots, "right")
    ])
  ]);
}
const ce = /* @__PURE__ */ G(ie, [["render", de]]);
const _e = { class: "cf-dropdown-body" }, pe = {
  __name: "Dropdown",
  setup(o) {
    const t = C(!1), e = y(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (n, a) => (l(), s("div", {
      class: B(e.value)
    }, [
      r("div", {
        class: "cf-dropdown-toggle",
        onClick: a[0] || (a[0] = (i) => t.value = !t.value)
      }, [
        f(n.$slots, "toggle")
      ]),
      r("div", _e, [
        f(n.$slots, "body")
      ]),
      r("div", {
        class: "cf-dropdown-backdrop",
        onClick: a[1] || (a[1] = (i) => t.value = !1)
      })
    ], 2));
  }
};
const fe = {
  key: 0,
  class: "cf-app-bar-link"
}, ve = { class: "cf-app-bar-link__label" }, me = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), be = {
  key: 1,
  class: "cf-app-bar-link"
}, he = { class: "cf-app-bar-link__label" }, jl = {
  __name: "AppBarLink",
  props: {
    dropdown: Boolean
  },
  setup(o) {
    return (t, e) => o.dropdown ? (l(), s("div", fe, [
      M(pe, null, {
        toggle: $(() => [
          r("div", ve, [
            f(t.$slots, "default"),
            me
          ])
        ]),
        body: $(() => [
          f(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (l(), s("button", be, [
      r("div", he, [
        f(t.$slots, "default")
      ])
    ]));
  }
};
const Rl = {
  __name: "AppView",
  props: { wide: Boolean },
  setup(o) {
    const t = o, e = y(() => ({
      "cf-app-view": !0,
      "cf-app-view--wide": t.wide
    }));
    return (n, a) => (l(), s("div", {
      class: B(e.value)
    }, [
      f(n.$slots, "default")
    ], 2));
  }
};
const ye = { class: "cf-app-view-header" }, ge = { key: 0 }, $e = { key: 1 }, ke = { key: 2 }, Se = {
  key: 3,
  class: "cf-app-view-header-actions"
}, Il = {
  __name: "AppViewHeader",
  props: {
    surtitle: String,
    title: String,
    description: String
  },
  setup(o) {
    const t = o, e = O();
    return (n, a) => (l(), s("header", ye, [
      t.surtitle ? (l(), s("p", ge, u(t.surtitle), 1)) : c("", !0),
      t.title ? (l(), s("h1", $e, u(t.title), 1)) : c("", !0),
      t.description ? (l(), s("p", ke, u(t.description), 1)) : c("", !0),
      q(e).actions ? (l(), s("div", Se, [
        f(n.$slots, "actions")
      ])) : c("", !0)
    ]));
  }
};
const Ul = {
  __name: "Banner",
  props: {
    type: String
  },
  setup(o) {
    const t = o, e = y(() => ({
      "cf-banner": !0,
      [`cf-banner--${t.type}`]: t.type
    }));
    return (n, a) => (l(), s("div", {
      class: B(e.value)
    }, [
      f(n.$slots, "default")
    ], 2));
  }
};
const we = { class: "cf-breadcrumbs" }, xe = { key: 0 }, Kl = {
  __name: "Breadcrumbs",
  props: { data: Array },
  setup(o) {
    const t = o;
    return (e, n) => {
      const a = D("RouterLink");
      return l(), s("ol", we, [
        (l(!0), s(x, null, V(t.data, (i) => (l(), s("li", {
          key: i.name
        }, [
          i.path ? (l(), k(a, {
            key: 1,
            to: i.path
          }, {
            default: $(() => [
              A(u(i.name), 1)
            ]),
            _: 2
          }, 1032, ["to"])) : (l(), s("span", xe, u(i.name), 1))
        ]))), 128))
      ]);
    };
  }
}, W = {
  to: {
    type: [String, Object],
    default: null
  },
  type: {
    type: String,
    default: "button"
  },
  large: Boolean,
  wide: Boolean,
  color: {
    type: String,
    default: null
  },
  loading: Boolean,
  disabled: Boolean
};
const Ce = ["type", "disabled"], Hl = {
  __name: "FilledButton",
  props: W,
  setup(o) {
    const t = o, e = y(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-filled-button": !0,
      [`cf-filled-button--${t.color}`]: t.color
    }));
    return (n, a) => {
      const i = D("router-link");
      return n.to ? (l(), k(i, {
        key: 0,
        class: B(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          f(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: B(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        f(n.$slots, "default")
      ], 10, Ce));
    };
  }
};
const Ve = ["type", "disabled"], Be = {
  __name: "OutlinedButton",
  props: W,
  setup(o) {
    const t = o, e = y(() => ({
      "cf-button": !0,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled,
      "cf-outlined-button": !0,
      [`cf-outlined-button--${t.color}`]: t.color
    }));
    return (n, a) => {
      const i = D("router-link");
      return n.to ? (l(), k(i, {
        key: 0,
        class: B(e.value),
        to: n.to,
        inert: t.disabled
      }, {
        default: $(() => [
          f(n.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to", "inert"])) : (l(), s("button", {
        key: 1,
        class: B(e.value),
        type: t.type,
        disabled: t.disabled
      }, [
        f(n.$slots, "default")
      ], 10, Ve));
    };
  }
};
const Ae = ["disabled"], Pl = {
  __name: "TextButton",
  props: {
    to: String,
    disabled: Boolean
  },
  setup(o) {
    const t = o;
    return (e, n) => {
      const a = D("router-link");
      return o.to ? (l(), k(a, {
        key: 0,
        class: "cf-text-button",
        to: o.to,
        inert: t.disabled
      }, {
        default: $(() => [
          f(e.$slots, "default")
        ]),
        _: 3
      }, 8, ["to", "inert"])) : (l(), s("button", {
        key: 1,
        class: "cf-text-button",
        type: "button",
        disabled: t.disabled
      }, [
        f(e.$slots, "default")
      ], 8, Ae));
    };
  }
};
const Le = { class: "cf-choice" }, Te = ["type", "id", "name", "value", "true-value", "false-value", "required", "disabled"], qe = ["for"], De = { key: 1 }, Ne = {
  __name: "Choice",
  props: {
    modelValue: [Number, String, Boolean, Object, Array],
    value: [Number, String, Boolean, Object],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    type: String,
    label: [String, Boolean],
    helper: String,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = Math.random(), a = {
      name: I("choice-list-name", null),
      required: I("choice-list-required", null)
    }, i = y({
      get() {
        return e.modelValue;
      },
      set(d) {
        t("update:modelValue", d);
      }
    });
    return (d, v) => (l(), s("div", Le, [
      z(r("input", {
        "onUpdate:modelValue": v[0] || (v[0] = (b) => i.value = b),
        type: e.type,
        id: q(n),
        name: a.name,
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        required: a.required,
        disabled: e.disabled
      }, null, 8, Te), [
        [H, i.value]
      ]),
      o.label ? (l(), s("label", {
        key: 0,
        for: q(n)
      }, u(e.label || e.value), 9, qe)) : c("", !0),
      e.helper ? (l(), s("small", De, u(e.helper), 1)) : c("", !0)
    ]));
  }
};
const Me = {
  key: 0,
  class: "cf-choice-list__label"
}, El = {
  __name: "ChoiceList",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    choices: Array,
    multiple: Boolean,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = y(() => ({
      "cf-choice-list": !0,
      "cf-choice-list--disabled": e.disabled
    })), a = y({
      get() {
        return e.modelValue;
      },
      set(i) {
        t("update:modelValue", i);
      }
    });
    return U("choice-list-name", Math.random()), U("choice-list-required", e.required), (i, d) => (l(), s("div", {
      class: B(n.value)
    }, [
      e.label ? (l(), s("div", Me, u(e.label), 1)) : c("", !0),
      (l(!0), s(x, null, V(o.choices, (v) => (l(), k(Ne, {
        key: v.value || v,
        type: e.multiple ? "checkbox" : "radio",
        label: v.label || v.value || v,
        helper: v.helper,
        value: v.value || v,
        disabled: e.disabled,
        modelValue: a.value,
        "onUpdate:modelValue": d[0] || (d[0] = (b) => a.value = b)
      }, null, 8, ["type", "label", "helper", "value", "disabled", "modelValue"]))), 128)),
      f(i.$slots, "default")
    ], 2));
  }
};
function T(o) {
  return typeof o == "function" ? o() : q(o);
}
function ze(o, t, e) {
  const n = () => {
    var d, v;
    return new te(
      (d = T(t)) != null ? d : [],
      (v = T(e)) == null ? void 0 : v.fuseOptions
    );
  }, a = C(n());
  K(
    () => {
      var d;
      return (d = T(e)) == null ? void 0 : d.fuseOptions;
    },
    () => {
      a.value = n();
    },
    { deep: !0 }
  ), K(
    () => T(t),
    (d) => {
      a.value.setCollection(d);
    },
    { deep: !0 }
  );
  const i = y(() => {
    const d = T(e);
    if (d != null && d.matchAllWhenSearchEmpty && !T(o))
      return T(t).map((b, w) => ({ item: b, refIndex: w }));
    const v = d == null ? void 0 : d.resultLimit;
    return a.value.search(T(o), v ? { limit: v } : void 0);
  });
  return {
    fuse: a,
    results: i
  };
}
const X = {
  modelValue: [Number, String, Object],
  value: [Number, String, Object],
  label: String,
  disabled: Boolean,
  required: Boolean,
  helper: String,
  title: String,
  autofocus: Boolean
};
const Fe = { class: "cf-form-control" }, Oe = { key: 0 }, je = { class: "cf-form-control-widget" }, Re = { key: 0 }, Ie = ["disabled", "required", "type", "placeholder", "list", "step", "max", "min", "maxlength", "minlength", "pattern", "title", "autofocus"], Ue = { key: 1 }, Ke = { key: 1 }, J = {
  __name: "Input",
  props: {
    type: {
      type: String,
      default: "text"
    },
    placeholder: String,
    prefix: String,
    suffix: String,
    list: String,
    step: [Number, String],
    max: [Number, String],
    min: [Number, String],
    maxlength: [Number, String],
    minlength: [Number, String],
    pattern: String,
    ...X
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = C(!1), a = y(() => e.type.toLowerCase() === "password" ? n.value ? "text" : "password" : e.type), i = y({
      get: () => e.modelValue || e.value,
      set: (d) => t("update:modelValue", d)
    });
    return (d, v) => (l(), s("div", Fe, [
      e.label ? (l(), s("label", Oe, [
        A(u(e.label) + " ", 1),
        e.type.toLowerCase() === "password" ? (l(), s("button", {
          key: 0,
          type: "button",
          tabindex: "-1",
          onClick: v[0] || (v[0] = (b) => n.value = !n.value)
        }, u(n.value ? "Hide" : "Show"), 1)) : c("", !0)
      ])) : c("", !0),
      r("div", je, [
        e.prefix ? (l(), s("div", Re, u(e.prefix), 1)) : c("", !0),
        z(r("input", {
          "onUpdate:modelValue": v[1] || (v[1] = (b) => i.value = b),
          disabled: e.disabled,
          required: e.required,
          type: a.value,
          placeholder: e.placeholder,
          list: e.list,
          step: e.step,
          max: e.max,
          min: e.min,
          maxlength: e.maxlength,
          minlength: e.minlength,
          pattern: e.pattern,
          title: e.title,
          autofocus: e.autofocus
        }, null, 8, Ie), [
          [H, i.value]
        ]),
        e.suffix ? (l(), s("div", Ue, u(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", Ke, u(e.helper), 1)) : c("", !0)
    ]));
  }
}, He = {
  key: 0,
  class: "cf-data-table-title"
}, Pe = {
  key: 1,
  class: "cf-data-table-description"
}, Ee = {
  key: 2,
  class: "cf-data-table-search"
}, Ze = {
  key: 3,
  class: "cf-data-table-action"
}, Ge = {
  __name: "DataTableHeader",
  props: {
    title: String,
    description: String,
    searchable: Boolean,
    search: String
  },
  emits: ["update:search"],
  setup(o, { emit: t }) {
    const e = o, n = O(), a = y({
      get: () => e.search,
      set: (i) => t("update:search", i)
    });
    return (i, d) => (l(), s("header", null, [
      e.title ? (l(), s("div", He, u(e.title), 1)) : c("", !0),
      e.description ? (l(), s("div", Pe, u(e.description), 1)) : c("", !0),
      e.searchable ? (l(), s("div", Ee, [
        M(J, {
          modelValue: a.value,
          "onUpdate:modelValue": d[0] || (d[0] = (v) => a.value = v),
          label: "Search"
        }, null, 8, ["modelValue"])
      ])) : c("", !0),
      q(n).default ? (l(), s("div", Ze, [
        f(i.$slots, "default")
      ])) : c("", !0)
    ]));
  }
}, We = {
  key: 0,
  "data-table-checkbox": ""
}, Xe = ["value", "checked", "disabled"], Je = {
  key: 1,
  "data-table-row-actions": ""
}, Qe = { key: 0 }, Ye = {
  __name: "DataTableRow",
  props: {
    data: Object,
    columns: Array,
    forceMenu: Boolean,
    includeCheckbox: Boolean
  },
  emits: ["toggle", "action"],
  setup(o, { emit: t }) {
    const e = o, n = y(() => e.data._), a = y(() => e.data.data), i = y(() => e.forceMenu || n.value.actions.length > 1), d = y(() => n.value.actions.map((b) => {
      const w = b.name || b, p = b.key || w.toUpperCase().replaceAll(" ", "_"), _ = () => t("action", { key: p, data: a.value });
      let S = "button";
      return b.to && (S = Z), b.href && (S = "a"), {
        label: w,
        to: b.to,
        href: b.href,
        key: p,
        invoke: _,
        component: S
      };
    })), v = y(() => {
      const b = {
        component: "button",
        label: "•••",
        invoke: null
      };
      return i.value ? b : d.value[0];
    });
    return (b, w) => (l(), s("tr", null, [
      e.includeCheckbox ? (l(), s("td", We, [
        r("input", {
          type: "checkbox",
          value: a.value.id,
          checked: n.value.isSelected,
          disabled: !n.value.isSelectable,
          onChange: w[0] || (w[0] = (p) => t("toggle"))
        }, null, 40, Xe)
      ])) : c("", !0),
      f(b.$slots, "default", {}, () => [
        (l(!0), s(x, null, V(e.columns, (p) => {
          var _;
          return l(), s("td", {
            key: p.key
          }, u((_ = q(R)(a.value, p.key)) == null ? void 0 : _.toLocaleString()), 1);
        }), 128))
      ]),
      n.value.actions ? (l(), s("td", Je, [
        (l(), k(F(v.value.component), {
          to: v.value.to,
          href: v.value.href,
          onClick: v.value.invoke
        }, {
          default: $(() => [
            A(u(v.value.label), 1)
          ]),
          _: 1
        }, 8, ["to", "href", "onClick"])),
        i.value ? (l(), s("div", Qe, [
          (l(!0), s(x, null, V(d.value, (p) => (l(), k(F(p.component), {
            key: p.key,
            to: p.to,
            href: p.href,
            onClick: p.invoke
          }, {
            default: $(() => [
              A(u(p.label), 1)
            ]),
            _: 2
          }, 1032, ["to", "href", "onClick"]))), 128))
        ])) : c("", !0)
      ])) : c("", !0)
    ]));
  }
};
const et = { class: "cf-data-table" }, tt = {
  key: 0,
  style: { "--w": "3rem" }
}, lt = {
  key: 1,
  style: { "--w": "4rem" }
}, st = {
  key: 0,
  "data-table-checkbox": ""
}, ot = ["disabled"], nt = ["onClick"], at = { key: 1 }, rt = { key: 1 }, Zl = {
  __name: "DataTable",
  props: {
    title: String,
    description: String,
    data: {
      type: Array,
      default: () => []
    },
    columns: {
      type: Array,
      default: () => []
    },
    selection: {
      type: Array,
      default: []
    },
    rowActions: [Boolean, Array],
    forceRowMenu: Boolean,
    customTemplate: Boolean,
    selectable: Boolean,
    sortable: Boolean,
    defaultSortKey: {
      type: String,
      default: ""
    },
    searchable: Boolean
  },
  emits: ["update:selection", "row-action"],
  setup(o, { emit: t }) {
    const e = o, n = O(), a = C(e.defaultSortKey), i = C("asc"), d = C(""), v = y(() => {
      if (e.searchable) {
        const { results: m } = ze(d, e.data, {
          fuseOptions: {
            keys: e.columns.map(({ key: g }) => g),
            minMatchCharLength: 2,
            threshold: 0.15
          },
          matchAllWhenSearchEmpty: !0
        });
        return m.value;
      } else
        return e.data;
    }), b = y(() => v.value.map((m) => m.item || m).sort((m, g) => {
      const h = R(m, a.value), L = R(g, a.value);
      return typeof h == "string" ? i.value === "asc" ? h == null ? void 0 : h.localeCompare(L) : L == null ? void 0 : L.localeCompare(h) : i.value === "asc" ? h - L : L - h;
    }).map(({ _: m, ...g }) => ({
      _: {
        isDisabled: (m == null ? void 0 : m.disabled) ?? !1,
        isSelectable: (m == null ? void 0 : m.seletable) ?? !0,
        isSelected: e.selection.includes(g.id),
        actions: (m == null ? void 0 : m.actions) ?? e.rowActions
      },
      data: g
    }))), w = y(() => b.value.some((m) => m._.isSelectable)), p = y({
      get: () => {
        const m = b.value.filter((g) => g._.isSelectable).length;
        return m >= 1 && m === e.selection.length;
      },
      set: (m) => {
        let g = [];
        m === !0 && (g = b.value.filter((h) => !h._.isDisabled && h._.isSelectable).map((h) => h.data.id)), t("update:selection", g);
      }
    }), _ = (m) => {
      const g = e.selection.includes(m) ? e.selection.slice().filter((h) => m !== h) : e.selection.concat(m);
      t("update:selection", g);
    }, S = (m) => {
      a.value === m ? i.value = i.value === "asc" ? "desc" : "asc" : (a.value = m, i.value = "asc");
    };
    return (m, g) => (l(), s("div", et, [
      e.title || e.description || e.searchable || q(n).header ? (l(), k(Ge, {
        key: 0,
        search: d.value,
        "onUpdate:search": g[0] || (g[0] = (h) => d.value = h),
        title: e.title,
        description: e.description,
        searchable: e.searchable
      }, {
        default: $(() => [
          f(m.$slots, "header")
        ]),
        _: 3
      }, 8, ["search", "title", "description", "searchable"])) : c("", !0),
      r("table", null, [
        r("colgroup", null, [
          e.selectable ? (l(), s("col", tt)) : c("", !0),
          (l(!0), s(x, null, V(e.columns, (h) => (l(), s("col", {
            key: h.key,
            style: Y({ "--w": h.width })
          }, null, 4))), 128)),
          e.rowActions ? (l(), s("col", lt)) : c("", !0)
        ]),
        r("thead", null, [
          r("tr", null, [
            e.selectable ? (l(), s("th", st, [
              z(r("input", {
                "onUpdate:modelValue": g[1] || (g[1] = (h) => p.value = h),
                type: "checkbox",
                disabled: !w.value
              }, null, 8, ot), [
                [P, p.value]
              ])
            ])) : c("", !0),
            (l(!0), s(x, null, V(e.columns, (h) => (l(), s("th", {
              key: h.key
            }, [
              e.sortable ? (l(), s("button", {
                key: 0,
                onClick: (L) => S(h.key)
              }, u(h.label), 9, nt)) : (l(), s("div", at, u(h.label), 1))
            ]))), 128)),
            e.rowActions ? (l(), s("th", rt)) : c("", !0)
          ])
        ]),
        r("tbody", null, [
          (l(!0), s(x, null, V(b.value, (h) => (l(), k(Ye, {
            key: h.data.id,
            data: h,
            columns: e.columns,
            "include-checkbox": e.selectable,
            "force-menu": e.forceRowMenu,
            onToggle: (L) => _(h.data.id),
            onAction: g[2] || (g[2] = (L) => t("row-action", L))
          }, {
            default: $(() => [
              f(m.$slots, "row", {
                data: h.data
              })
            ]),
            _: 2
          }, 1032, ["data", "columns", "include-checkbox", "force-menu", "onToggle"]))), 128))
        ])
      ])
    ]));
  }
};
const it = { class: "cf-sidebar-nav" }, ut = /* @__PURE__ */ r("hr", null, null, -1), dt = /* @__PURE__ */ r("span", { class: "material-symbols-outlined" }, null, -1), ct = /* @__PURE__ */ r("span", null, "Collapse sidebar", -1), _t = [
  dt,
  ct
], pt = {
  __name: "Sidebar",
  setup(o) {
    const t = C(!1), e = y(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (n, a) => (l(), s("aside", {
      class: B(e.value)
    }, [
      r("nav", it, [
        f(n.$slots, "default"),
        ut
      ]),
      r("button", {
        class: "cf-sidebar-toggle",
        onClick: a[0] || (a[0] = (i) => t.value = !t.value)
      }, _t)
    ], 2));
  }
};
const Gl = {
  __name: "AppLayout",
  setup(o) {
    return E(() => {
      document.body.dataset.layout = "app";
    }), (t, e) => (l(), s(x, null, [
      M(ce, null, {
        left: $(() => [
          f(t.$slots, "brand")
        ]),
        right: $(() => [
          f(t.$slots, "navigation")
        ]),
        _: 3
      }),
      M(pt, null, {
        default: $(() => [
          f(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      r("main", null, [
        f(t.$slots, "main")
      ])
    ], 64));
  }
};
const ft = ["onKeydown"], vt = { class: "cf-dialog-header" }, mt = { class: "cf-dialog__title" }, bt = { key: 0 }, ht = { class: "cf-dialog-body" }, yt = { class: "cf-dialog-footer" }, gt = ["disabled"], $t = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), kt = [
  $t
], Wl = {
  __name: "Dialog",
  props: {
    title: String,
    description: String,
    persist: {
      type: Boolean,
      default: !1
    },
    persistent: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["close"],
  setup(o, { emit: t }) {
    const e = o, n = C(), a = () => {
      !e.persist && !e.persistent && t("close");
    };
    return E(() => n.value.showModal()), (i, d) => (l(), s("dialog", {
      class: "cf-dialog",
      ref_key: "dialog",
      ref: n,
      onKeydown: j(N(a, ["prevent"]), ["esc"])
    }, [
      r("div", vt, [
        r("div", mt, u(e.title), 1),
        e.description ? (l(), s("div", bt, u(e.description), 1)) : c("", !0)
      ]),
      r("div", ht, [
        f(i.$slots, "body")
      ]),
      r("div", yt, [
        f(i.$slots, "footer")
      ]),
      e.persistent ? c("", !0) : (l(), s("button", {
        key: 0,
        class: "cf-dialog-close",
        disabled: e.persist,
        onClick: a
      }, kt, 8, gt))
    ], 40, ft));
  }
};
const St = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, wt = { class: "material-symbols-outlined" }, xt = { class: "cf-dropdown-item__label" }, Ct = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Vt = { class: "material-symbols-outlined" }, Bt = { class: "cf-dropdown-item__label" }, Xl = {
  __name: "DropdownItem",
  props: {
    icon: String,
    to: [Object, String],
    large: Boolean
  },
  setup(o) {
    const t = o, e = y(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (n, a) => {
      const i = D("router-link");
      return o.to ? (l(), k(i, {
        key: 1,
        class: B(e.value),
        to: o.to
      }, {
        default: $(() => [
          o.icon ? (l(), s("div", Ct, [
            r("span", Vt, u(o.icon), 1)
          ])) : c("", !0),
          r("div", Bt, [
            f(n.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (l(), s("button", {
        key: 0,
        class: B(e.value)
      }, [
        o.icon ? (l(), s("div", St, [
          r("span", wt, u(o.icon), 1)
        ])) : c("", !0),
        r("div", xt, [
          f(n.$slots, "default")
        ])
      ], 2));
    };
  }
};
const At = { class: "cf-drop-zone" }, Lt = ["onDrop"], Tt = { class: "cf-drop-zone-box__label" }, qt = { class: "cf-drop-zone-box__action" }, Dt = /* @__PURE__ */ r("span", null, "select from device", -1), Nt = ["required"], Mt = {
  key: 0,
  class: "cf-drop-zone-box__helper"
}, zt = {
  key: 1,
  class: "cf-drop-zone-list"
}, Ft = /* @__PURE__ */ r("div", { class: "cf-drop-zone-list__header" }, null, -1), Ot = { class: "cf-drop-zone-list__item" }, jt = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "12",
  height: "12"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Rt = [
  jt
], Jl = {
  __name: "DropZone",
  props: {
    modelValue: File,
    label: {
      type: String,
      default: "Add your file here."
    },
    max: {
      type: [Number, String],
      default: 0
    },
    accept: String,
    required: Boolean
  },
  emits: ["update:modelValue", "add", "cancel"],
  setup(o, { emit: t }) {
    const e = o, n = C(null), a = y(() => !!(e.required && !e.modelValue)), i = y(() => {
      if (e.modelValue) {
        const _ = (e.modelValue.size / 1048576).toFixed(0), S = (_ / 1e3).toFixed(1);
        return _ < 100 ? `${_} MB` : `${S} GB`;
      } else
        return "0 MB";
    }), d = (p) => {
      const _ = p.target.files[0];
      b(_);
    }, v = (p) => {
      const _ = p.dataTransfer.files[0];
      b(_);
    }, b = (p) => {
      const _ = parseInt(e.max) * 1048576;
      _ && _ < p.size ? (n.value.value = "", alert(`File cannot exceed ${e.max} MB`)) : (t("update:modelValue", p), t("add", p));
    }, w = () => {
      t("update:modelValue", null), t("cancel");
    };
    return (p, _) => (l(), s("div", At, [
      o.modelValue ? (l(), s("div", zt, [
        Ft,
        r("div", Ot, [
          r("div", null, u(e.modelValue.name), 1),
          r("div", null, u(i.value), 1),
          r("button", { onClick: w }, Rt)
        ])
      ])) : (l(), s("div", {
        key: 0,
        class: "cf-drop-zone-box",
        onDrop: N(v, ["prevent"]),
        onDragenter: _[0] || (_[0] = N(() => {
        }, ["prevent"])),
        onDragover: _[1] || (_[1] = N(() => {
        }, ["prevent"])),
        onDragleave: _[2] || (_[2] = N(() => {
        }, ["prevent"]))
      }, [
        r("div", Tt, u(e.label), 1),
        r("label", qt, [
          A(" Drag and drop or "),
          Dt,
          r("input", {
            type: "file",
            ref_key: "input",
            ref: n,
            required: a.value,
            onChange: d
          }, null, 40, Nt)
        ]),
        e.max ? (l(), s("div", Mt, " Files larger than " + u(e.max) + " MB cannot be uploaded ", 1)) : c("", !0)
      ], 40, Lt))
    ]));
  }
};
const It = { class: "cf-tag" }, Ut = /* @__PURE__ */ r("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16",
  height: "16"
}, [
  /* @__PURE__ */ r("path", { d: "M14.34 13.605L8.696 8.023l5.582-5.645-.71-.703-5.583 5.644L2.34 1.737l-.703.711L7.282 8.03 1.7 13.675l.71.703 5.583-5.645 5.644 5.583.703-.711z" })
], -1), Kt = [
  Ut
], Q = {
  __name: "Tag",
  props: {
    removable: {
      type: Boolean,
      default: !0
    }
  },
  emits: ["remove"],
  setup(o, { emit: t }) {
    const e = o;
    return (n, a) => (l(), s("div", It, [
      r("span", null, [
        f(n.$slots, "default")
      ]),
      e.removable ? (l(), s("button", {
        key: 0,
        onClick: a[0] || (a[0] = (i) => t("remove"))
      }, Kt)) : c("", !0)
    ]));
  }
};
const Ht = { class: "cf-file-picker" }, Pt = {
  key: 0,
  class: "cf-file-picker-label"
}, Et = {
  key: 1,
  class: "cf-button cf-file-picker-button"
}, Zt = ["required"], Ql = {
  __name: "FilePicker",
  props: {
    modelValue: File,
    label: String,
    action: {
      type: String,
      default: "Choose file"
    },
    required: Boolean
  },
  emits: ["update:modelValue", "change"],
  setup(o, { emit: t }) {
    const e = o, n = (i) => {
      t("update:modelValue", i.target.files[0]), t("change", i);
    }, a = () => {
      t("update:modelValue", null);
    };
    return (i, d) => (l(), s("div", Ht, [
      e.label ? (l(), s("div", Pt, u(e.label), 1)) : c("", !0),
      e.modelValue ? (l(), k(Q, {
        key: 2,
        onRemove: a
      }, {
        default: $(() => {
          var v;
          return [
            A(u((v = e.modelValue) == null ? void 0 : v.name), 1)
          ];
        }),
        _: 1
      })) : (l(), s("label", Et, [
        A(u(e.action) + " ", 1),
        r("input", {
          type: "file",
          onChange: n,
          required: o.required
        }, null, 40, Zt)
      ]))
    ]));
  }
};
const Gt = { class: "cf-header" }, Wt = { key: 0 }, Xt = { key: 1 }, Jt = { key: 0 }, Yl = {
  __name: "Header",
  props: {
    size: {
      type: String,
      default: "h4"
    },
    title: String,
    surtitle: String,
    subtitle: String
  },
  setup(o) {
    const t = o, e = O();
    return (n, a) => (l(), s("div", Gt, [
      r("div", null, [
        t.surtitle ? (l(), s("p", Wt, u(t.surtitle), 1)) : c("", !0),
        (l(), k(F(t.size), null, {
          default: $(() => [
            A(u(t.title), 1)
          ]),
          _: 1
        })),
        t.subtitle ? (l(), s("p", Xt, u(t.subtitle), 1)) : c("", !0)
      ]),
      q(e).action ? (l(), s("div", Jt, [
        f(n.$slots, "action")
      ])) : c("", !0)
    ]));
  }
};
const Qt = ["value", "max"], es = {
  __name: "Progress",
  props: {
    value: {
      type: [Number, String],
      default: 0
    },
    max: {
      type: [Number, String],
      default: 100
    }
  },
  setup(o) {
    const t = o;
    return (e, n) => (l(), s("progress", {
      class: "cf-progress",
      value: t.value,
      max: t.max
    }, u(o.value) + "% ", 9, Qt));
  }
};
const Yt = { class: "cf-form-control" }, el = { key: 0 }, tl = { class: "cf-form-control-widget" }, ll = { key: 0 }, sl = ["disabled", "required", "title", "autofocus"], ol = {
  key: 0,
  value: null
}, nl = ["value", "disabled"], al = { key: 1 }, rl = { key: 1 }, il = {
  __name: "Select",
  props: {
    options: Array,
    ...X
  },
  emits: ["update:modelValue", "input"],
  setup(o, { emit: t }) {
    const e = o, n = y({
      get: () => e.modelValue || e.value,
      set: (a) => {
        t("update:modelValue", a), t("input", { data: a });
      }
    });
    return (a, i) => (l(), s("div", Yt, [
      e.label ? (l(), s("label", el, u(e.label), 1)) : c("", !0),
      r("div", tl, [
        e.prefix ? (l(), s("div", ll, u(e.prefix), 1)) : c("", !0),
        z(r("select", {
          "onUpdate:modelValue": i[0] || (i[0] = (d) => n.value = d),
          disabled: e.disabled,
          required: e.required,
          title: e.title,
          autofocus: e.autofocus
        }, [
          !e.required && e.options.length ? (l(), s("option", ol)) : c("", !0),
          (l(!0), s(x, null, V(e.options, (d) => (l(), s("option", {
            key: d.value || d,
            value: d.value || d,
            disabled: d.disabled ?? !1
          }, u(d.label || d), 9, nl))), 128)),
          f(a.$slots, "default")
        ], 8, sl), [
          [ee, n.value]
        ]),
        e.suffix ? (l(), s("div", al, u(e.suffix), 1)) : c("", !0)
      ]),
      e.helper ? (l(), s("small", rl, u(e.helper), 1)) : c("", !0)
    ]));
  }
};
const ul = { key: 0 }, dl = { class: "material-symbols-outlined" }, cl = {
  key: 1,
  class: "cf-sidebar-link-group"
}, _l = { class: "cf-sidebar-link" }, pl = { class: "material-symbols-outlined" }, fl = { class: "cf-sidebar-link-children" }, ts = {
  __name: "SidebarLink",
  props: {
    to: [String, Object],
    href: String,
    icon: String,
    parent: Boolean
  },
  setup(o) {
    const t = o, e = y(() => t.to ? Z : "a");
    return (n, a) => t.parent ? (l(), s("div", cl, [
      r("button", _l, [
        r("figure", null, [
          r("span", pl, u(t.icon), 1)
        ]),
        r("span", null, [
          f(n.$slots, "default")
        ])
      ]),
      r("div", fl, [
        f(n.$slots, "children")
      ])
    ])) : (l(), k(F(e.value), {
      key: 0,
      class: "cf-sidebar-link",
      to: t.to,
      href: t.href
    }, {
      default: $(() => [
        t.icon ? (l(), s("figure", ul, [
          r("span", dl, u(t.icon), 1)
        ])) : c("", !0),
        r("span", null, [
          f(n.$slots, "default")
        ])
      ]),
      _: 3
    }, 8, ["to", "href"]));
  }
};
const vl = {}, ml = { class: "cf-spinner" }, bl = /* @__PURE__ */ r("div", null, null, -1), hl = /* @__PURE__ */ r("div", null, null, -1), yl = /* @__PURE__ */ r("div", null, null, -1), gl = /* @__PURE__ */ r("div", null, null, -1), $l = [
  bl,
  hl,
  yl,
  gl
];
function kl(o, t) {
  return l(), s("div", ml, $l);
}
const ls = /* @__PURE__ */ G(vl, [["render", kl]]);
const Sl = { class: "cf-summary-list" }, ss = {
  __name: "SummaryList",
  props: {
    data: {
      type: Array,
      default: () => []
    }
  },
  setup(o) {
    const t = o;
    return (e, n) => (l(), s("dl", Sl, [
      (l(!0), s(x, null, V(t.data, (a) => (l(), s(x, null, [
        r("dt", null, u(a.label), 1),
        r("dd", null, u(a.value), 1)
      ], 64))), 256))
    ]));
  }
};
const wl = { class: "cf-switch" }, xl = ["value", "true-value", "false-value", "disabled"], Cl = {
  key: 0,
  class: "cf-switch__label"
}, os = {
  __name: "Switch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = y({
      get() {
        return e.modelValue;
      },
      set(a) {
        t("update:modelValue", a);
      }
    });
    return (a, i) => (l(), s("div", wl, [
      z(r("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": i[0] || (i[0] = (d) => n.value = d),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, xl), [
        [P, n.value]
      ]),
      e.label ? (l(), s("div", Cl, u(e.label), 1)) : c("", !0)
    ]));
  }
};
const Vl = { class: "cf-navigation-tabs" }, ns = {
  __name: "TabNavigation",
  props: {
    tabs: Array
  },
  setup(o) {
    const t = o;
    return (e, n) => {
      const a = D("router-link");
      return l(), s("nav", Vl, [
        r("ul", null, [
          (l(!0), s(x, null, V(t.tabs, (i, d) => (l(), s("li", { key: d }, [
            M(a, {
              to: i.to
            }, {
              default: $(() => [
                A(u(i.label), 1)
              ]),
              _: 2
            }, 1032, ["to"])
          ]))), 128))
        ])
      ]);
    };
  }
};
const Bl = ["inert"], Al = { key: 0 }, Ll = { class: "cf-tags-field__input" }, Tl = ["required"], ql = { class: "cf-tags-field__tags" }, Dl = { key: 1 }, as = {
  __name: "TagsField",
  props: {
    modelValue: Array,
    label: String,
    buttonText: {
      type: String,
      default: "Add"
    },
    prefix: String,
    options: Array,
    helper: String,
    disabled: Boolean,
    required: Boolean
  },
  emits: ["update:modelValue"],
  setup(o, { emit: t }) {
    const e = o, n = C(!1), a = C(""), i = y(() => {
      var p;
      return (p = e.options) == null ? void 0 : p.map((_) => ({
        label: _.label || _,
        value: _.value || _
      }));
    }), d = y(() => {
      var p;
      return (p = i.value) == null ? void 0 : p.filter(
        (_) => !e.modelValue.includes(_.value)
      );
    }), v = (p) => i.value.find((_) => _.value === p).label, b = () => {
      if (!a.value || e.disabled)
        return !1;
      const p = e.modelValue;
      p.push(a.value), t("update:modelValue", p), a.value = "", n.value = !1;
    }, w = (p) => {
      if (e.disabled)
        return !1;
      const _ = e.modelValue;
      _.splice(p, 1), t("update:modelValue", _);
    };
    return (p, _) => (l(), s("div", {
      class: "cf-tags-field",
      inert: e.disabled
    }, [
      e.label ? (l(), s("label", Al, u(e.label), 1)) : c("", !0),
      r("div", Ll, [
        !e.options && n.value ? (l(), k(J, {
          key: 0,
          modelValue: a.value,
          "onUpdate:modelValue": _[0] || (_[0] = (S) => a.value = S),
          prefix: e.prefix,
          onKeydown: j(b, ["enter"]),
          onChange: b,
          required: ""
        }, null, 8, ["modelValue", "prefix", "onKeydown"])) : c("", !0),
        e.options && n.value ? (l(), k(il, {
          key: 1,
          modelValue: a.value,
          "onUpdate:modelValue": _[1] || (_[1] = (S) => a.value = S),
          options: d.value,
          onKeydown: j(b, ["enter"]),
          onChange: b,
          required: ""
        }, null, 8, ["modelValue", "options", "onKeydown"])) : c("", !0),
        n.value ? c("", !0) : (l(), k(Be, {
          key: 2,
          color: "blue",
          onClick: _[2] || (_[2] = (S) => n.value = !0)
        }, {
          default: $(() => [
            A(u(e.buttonText), 1)
          ]),
          _: 1
        })),
        r("input", {
          class: "cf-tags-field__input__faux",
          type: "text",
          required: e.required && !e.modelValue.length
        }, null, 8, Tl)
      ]),
      r("div", ql, [
        (l(!0), s(x, null, V(e.modelValue, (S, m) => (l(), k(Q, {
          key: S,
          onRemove: (g) => w(m)
        }, {
          default: $(() => [
            A(u(e.prefix) + " " + u(e.options ? v(S) : S), 1)
          ]),
          _: 2
        }, 1032, ["onRemove"]))), 128))
      ]),
      e.helper ? (l(), s("small", Dl, u(e.helper), 1)) : c("", !0)
    ], 8, Bl));
  }
};
export {
  Ol as CfActionCard,
  ce as CfAppBar,
  jl as CfAppBarLink,
  Gl as CfAppLayout,
  Rl as CfAppView,
  Il as CfAppViewHeader,
  Ul as CfBanner,
  Kl as CfBreadcrumbs,
  Ne as CfChoice,
  El as CfChoiceList,
  Zl as CfDataTable,
  Wl as CfDialog,
  Jl as CfDropZone,
  pe as CfDropdown,
  Xl as CfDropdownItem,
  Ql as CfFilePicker,
  Hl as CfFilledButton,
  Yl as CfHeader,
  J as CfInput,
  Be as CfOutlinedButton,
  es as CfProgress,
  il as CfSelect,
  pt as CfSidebar,
  ts as CfSidebarLink,
  ls as CfSpinner,
  ss as CfSummaryList,
  os as CfSwitch,
  ns as CfTabNavigation,
  Q as CfTag,
  as as CfTagsField,
  Pl as CfTextButton
};
